﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Net;
using System.Text;
using System.Text.RegularExpressions;
using System.Threading;
using System.Windows;
using System.Windows.Controls;
using System.Xml;
using AsReaderP252B;

namespace AsReaderP252B_Demo
{
    /// <summary>
    /// DeviceSearch.xaml 的交互逻辑
    /// </summary>
    public partial class DeviceSearch : Window
    {
        public delegate void DeviceSearchClose(SearchBluetoothDevice searchBluetoothDevices);
        public DeviceSearchClose deviceSearchClose = null;
        AsBluetoothManager asBluetoothManager = AsBluetoothManager.SharedAsBluetoothManager();
        List<SearchBluetoothDevice> searchBluetoothDeviceList = new List<SearchBluetoothDevice>();
        public DeviceSearch()
        {
            InitializeComponent();
            Dispatcher.ShutdownStarted += ShutdownStarted;
            SetDelegateMethod();
            btnSeach_Click(null, null);
        }
        private void ShutdownStarted(object sender, EventArgs e)
        {
            if (btnSeach.Content.ToString() == "Stop Search")
            {
                asBluetoothManager.StopSearching();
            }
        }
        void SetDelegateMethod()
        {
            asBluetoothManager.whenReceivedDeviceList = ReceivedDeviceList;
        }
        void ReceivedDeviceList(List<BluetoothDevice> devices)
        {
            searchBluetoothDeviceList.Clear();
            for (int i = 0; i < devices.Count; i++)
            {
                searchBluetoothDeviceList.Add(new SearchBluetoothDevice
                {
                    BluetoothDevice = devices[i],
                    DeviceIDShort = devices[i].DeviceID.Split(new char[] { '-' })[1],
                    DeviceName = devices[i].DeviceName
                });
            }
            this.Dispatcher.Invoke(new Action(() =>
            {
                dgDevices.ItemsSource = null;
                dgDevices.ItemsSource = searchBluetoothDeviceList;
            }));
        }

        private void btnSeach_Click(object sender, RoutedEventArgs e)
        {
            if (btnSeach.Content.ToString() == "Search")
            {
                dgDevices.ItemsSource = null;
                asBluetoothManager.StartSearching(Types.BluetoothType.BluetoothSPP);
                btnSeach.Content = "Stop Search";
            }
            else
            {
                asBluetoothManager.StopSearching();
                btnSeach.Content = "Search";
            }
        }

        private void btnSelect_Click(object sender, RoutedEventArgs e)
        {
            if (dgDevices.SelectedItem != null)
            {
                SearchBluetoothDevice selectDevice = (SearchBluetoothDevice)dgDevices.SelectedItem;
                deviceSearchClose(selectDevice);
                this.Close();
            }
        }
    }
}
